public class m11RPGid_Enemy {

	String name;
	int no;
	int hp;
	int mhp;
	int mp;
	int mmp;
	int at;
	int def;
	int mf;
	int exp;
	String image;
	m11RPGid_ScriptCode scriptList[];

	public m11RPGid_Enemy() {
	}

	public m11RPGid_Enemy(m11RPGid_Enemy src) {

		name = src.name;
		hp = src.hp;
		mhp = src.mhp;
		mp = src.mp;
		mmp = src.mmp;
		at = src.at;
		def = src.def;
		mf = src.mf;
		exp = src.exp;
		image = src.image;

		if (src.scriptList != null) {

			scriptList = new m11RPGid_ScriptCode[src.scriptList.length];

			for (int i = 0;i < src.scriptList.length;i++) {
				if (src.scriptList[i] == null) {
					scriptList[i] = null;
				} else {
					scriptList[i] = new m11RPGid_ScriptCode(src.scriptList[i]);
				}
			}

		}

	}

	public int getStatus(String item) {

		if (item.equals("hp")) {
			return hp;
		}

		if (item.equals("mhp")) {
			return mhp;
		}

		if (item.equals("mp")) {
			return mp;
		}

		if (item.equals("mmp")) {
			return mmp;
		}

		if (item.equals("at")) {
			return at;
		}

		if (item.equals("def")) {
			return def;
		}

		if (item.equals("mf")) {
			return mf;
		}

		if (item.equals("exp")) {
			return exp;
		}

		return 0;

	}

}
