/*
	giAvŃtB[hRPGvg^CvEI_CAO

	2011-05-04`2011-05-25 nvO~O̊X
*/
import com.nttdocomo.ui.*;
import java.util.*;

// I_CAO
public class m11RPGid_SelectDialog {

	public static final int PROCESS_STAGE_NONE = 0;
	public static final int PROCESS_STAGE_SELECT = 1;
	public static final int PROCESS_STAGE_DONE = 2;
	public static final int PROCESS_STAGE_EXIT = 3;

	public static final int DEFAULT_BORDER_SIZE = 1;
	public static final int DEFAULT_CONTENT_PADDING = 2;

	// \ʒu
	private int _x = 0;
	private int _y = 0;

	// EChȆ傫
	private int _width = 0;
	private int _height = 0;

	// OgTCY
	private int _border_size = DEFAULT_BORDER_SIZE;

	// g̈̍W
	private int _inner_x = 0;
	private int _inner_y = 0;

	// g̈̑傫
	private int _inner_width = 0;
	private int _inner_height = 0;

	// g]
	private int _content_padding = DEFAULT_CONTENT_PADDING;

	// Ï捶W
	private int _content_x = 0;
	private int _content_y = 0;

	// Ï̑傫
	private int _content_width = 0;
	private int _content_height = 0;

	// `tHg
	private Font _font = Font.getFont(Font.FACE_SYSTEM | Font.SIZE_SMALL | Font.STYLE_PLAIN);

	// s̍
	private int _item_height = _font.getHeight() + 4;

	// J[\L[EGCg
	private int _key_wait = 0;

	// ݂̑Iʒu
	private int _index = 0;

	// i`揈sjtO
	private boolean _visible = false;

	// IʒuJ[\TCY
	private int _cursor_size = 8;

	// ݂̏
	private int _process_stage = PROCESS_STAGE_NONE;

	// I
	private String[] _itemList = null;

	private int[] _cursorShapeX = new int[3];
	private int[] _cursorShapeY = new int[3];

	private boolean _cancelable = false;

	public m11RPGid_SelectDialog() {


	}

	// `掞XW擾
	public int getX() {
		return _x;
	}

	// `掞YW擾
	public int getY() {
		return _y;
	}

	// `掞̉擾
	public int getWidth() {
		return _width;
	}

	// `掞̍擾
	public int getHeight() {
		return _height;
	}

	// \ʒuݒ
	public void setPos(int x, int y) {

		_x = x;
		_y = y;

		_inner_x = x + _border_size;
		_inner_y = y + _border_size;

		_content_x = _inner_x + _content_padding;
		_content_y = _inner_y + _content_padding;

	}

	// Ԃ
	public void show() {
		_visible = true;
	}

	// sԂ
	public void hide() {
		_visible = false;
	}

	public void setCancelable(boolean f) {
		_cancelable = f;
	}

	// ݂̃J[\iIjʒu擾
	public int getIndex() {
		return _index;
	}

	public boolean setIndex(int i) {

		if (i < 0 || i >= _itemList.length) {
			return false;
		}

		_index = i;

		return true;

	}

	// Iݒ
	public void setItems(String[] items) {

		_itemList = new String[items.length];

		int maxWidth = 0;

		// I񒆂̍ő`敝擾
		for (int i = 0;i < items.length;i++) {

			_itemList[i] = new String(items[i]);

			if (_font.stringWidth(items[i]) > maxWidth) {
				maxWidth = _font.stringWidth(items[i]);
			}

		}

		// EChȆ傫ݒ
		_width = maxWidth + _cursor_size + (_content_padding * 2)+ (_border_size * 2);
		_height = items.length * _item_height + (_content_padding * 2) + (_border_size * 2);

		// g̈̑傫vZ
		_inner_width = _width - (_border_size * 2);
		_inner_height = _height - (_border_size * 2);

		// Ï̑傫vZ
		_content_width = _inner_width - (_content_padding * 2);
		_content_height = _inner_height - (_content_padding * 2);

		// Ԃ
		_key_wait = 0;
		_index = 0;
		_process_stage = PROCESS_STAGE_NONE;

	}

	// IԂ
	public void reset() {

		// Ԃ
		_key_wait = 0;
		_index = 0;

		_process_stage = PROCESS_STAGE_NONE;

	}

	// nꂽL[Ԃɉă_CAOԂXV
	public boolean process(m11RPGid_KeyStatusHolder key) {

		// L[EGCg0łȂ΃EGCg
		if (_key_wait > 0) {

			// L[ԂȂ疳ɃEGCgI
			if (key.getStick() == m11RPGid_KeyStatusHolder.KEYFLAG_NONE) {
				_key_wait = 0;
			} else {
				_key_wait--;
			}

		}

		switch (_process_stage) {

		// 
		case PROCESS_STAGE_NONE:

			// ^[L[҂đIԂ
			if (key.getTrigger() == 0) {
				_process_stage = PROCESS_STAGE_SELECT;
			}

			break;

		// I
		case PROCESS_STAGE_SELECT:

			// ^[L[ꂽIs
			if (key.getTrigger() == m11RPGid_KeyStatusHolder.KEYFLAG_SELECT) {

				_process_stage = PROCESS_STAGE_DONE;

				return false;

			}

			// NAL[ꂽLZs
			if (_cancelable && (key.getTrigger() == m11RPGid_KeyStatusHolder.KEYFLAG_CANCEL)) {

				_index = -1;

				_process_stage = PROCESS_STAGE_DONE;

				return false;

			}

			// EGCgłȂ΁A㉺L[͏
			if (_key_wait == 0) {

				// L[
				if (key.getStick() == m11RPGid_KeyStatusHolder.KEYFLAG_UP) {
					if (_index > 0) {

						// ݈ʒu
						_index--;

						// EGCgJn
						_key_wait = 10;

					} else {

						// ݈ʒuԉ
						_index = this._itemList.length - 1;

						// EGCgJn
						_key_wait = 10;

					}
				}

				// L[
				if (key.getStick() == m11RPGid_KeyStatusHolder.KEYFLAG_DOWN) {
					if (_index < _itemList.length -1) {

						// ݈ʒu
						_index++;

						// EGCgJn
						_key_wait = 10;

					} else {

						// ݈ʒuԏ
						_index = 0;

						// EGCgJn
						_key_wait = 10;

					}

				}

			}

			break;

		// Iςݏ
		case PROCESS_STAGE_DONE:

			// Iς݂Ń^[L[ꂽIԂƂtrueԂ
			if (key.getTrigger() == 0) {

				_process_stage = PROCESS_STAGE_EXIT;

				return true;

			}

			break;

		}

		return false;

	}

	public void draw(Graphics g) {

		if (!_visible) {
			return;
		}

		// EChËŜ𔒂ŃNA
		g.setColor(g.getColorOfRGB(255, 255, 255));
		g.fillRect(_x, _y, _width, _height);

		// ŃNA
		g.setColor(g.getColorOfRGB(0, 0, 0));
		g.fillRect(_inner_x, _inner_y, _inner_width, _inner_height);

		// `Fݒ
		g.setColor(g.getColorOfRGB(255, 255, 255));

		// `ptHgݒ
		g.setFont(_font);

		// I`
		for (int i = 0;i < _itemList.length;i++) {
			g.drawString(_itemList[i], _content_x + _cursor_size, _content_y + i * _item_height + ((_item_height - _font.getHeight()) / 2) + _font.getHeight());
		}

		// IJ[\̃|S`
		_cursorShapeX[1] = _content_x + _cursor_size - 2;
		_cursorShapeY[1] = _content_y +_index * _item_height + (_item_height / 2);

		_cursorShapeX[0] = _content_x + 1;
		_cursorShapeY[0] = _cursorShapeY[1] - (_cursor_size / 2);

		_cursorShapeX[2] = _content_x + 1;
		_cursorShapeY[2] = _cursorShapeY[1] + (_cursor_size / 2);

		// ݂̑IʒuɃJ[\`
		g.fillPolygon(_cursorShapeX, _cursorShapeY, 0, 3);

	}

}

