public class m11RPGid_PlayerItemHolder {

	public static final int ITEM_MAXNUM = 8;

	private m11RPGid_PlayerItem[] _list = new m11RPGid_PlayerItem[ITEM_MAXNUM];

	public m11RPGid_PlayerItem getItem(int index) {
		return _list[index];
	}

	public int getItemNum() {

		int num = 0;

		for (int i = 0;i < ITEM_MAXNUM;i++) {
			if (_list[i] != null) {
				num++;
			}
		}

		return num;

	}

	public int getItemSpace() {
		return ITEM_MAXNUM - getItemNum();
	}

	public int getNumOfItem(int no) {

		int num = 0;

		for (int i = 0;i < ITEM_MAXNUM;i++) {
			if (_list[i] != null && _list[i].no == no) {
				num++;
			}
		}

		return num;

	}

	public boolean addItem(m11RPGid_PlayerItem item) {

		for (int i = 0;i < ITEM_MAXNUM;i++) {
			if (_list[i] == null) {

				_list[i] = item;

				return true;
			}
		}

		return false;

	}

	// wACe폜
	public boolean decItem(int no) {

		for (int i = 0;i < _list.length;i++) {
			if (_list[i] != null && _list[i].no == no) {

				_list[i] = null;

				m11RPGid_PlayerItem[] list = new m11RPGid_PlayerItem[ITEM_MAXNUM];

				int k = 0;

				for (int j = 0;j < _list.length;j++) {
					if (_list[j] != null) {
						list[k++] = _list[j];
					}
				}

				_list = list;

				return true;

			}
		}

		return false;

	}

	// w^Cv̑iԂ
	public m11RPGid_PlayerItem getEquipItem(int t) {

		// i
		for (int i = 0;i < _list.length;i++) {
			if (_list[i] != null && _list[i].equip && _list[i].type == t) {
				return _list[i];
			}
		}

		return null;

	}

	// wACȇԂݒ
	public void setEquip(m11RPGid_PlayerItem item, boolean equip) {

		// ^Cvׂ̑ĊO
		for (int i = 0;i < _list.length;i++) {
			if (_list[i] != null && _list[i].type == item.type) {
				_list[i].equip = false;
			}
		}

		item.equip = equip;

	}

	public void deleteItem(m11RPGid_PlayerItem item) {

		int i, j = 0;

		m11RPGid_PlayerItem[] list = new m11RPGid_PlayerItem[ITEM_MAXNUM];

		for (i = 0;i < _list.length;i++) {
			if (_list[i] != null && _list[i] != item) {
				list[j++] = _list[i];
			}
		}

		_list = list;

	}

	public String getItemData() {

		String data = new String();

		for (int i = 0;i < _list.length;i++) {
			if (_list[i] != null) {

				if (data.length() > 0) {
					data += "\t";
				}

				data += String.valueOf(_list[i].no) + "," + String.valueOf(_list[i].useNum);

				if (_list[i].equip) {
					data += "," + "1";
				} else {
					data += "," + "0";
				}

			}
		}

		return data;

	}

}
